Index: /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4647)
+++ /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4648)
@@ -7340,30 +7083,27 @@
 
              number_of_particles = prt_count(k,j,i)
-             IF ( number_of_particles <= 0  .OR.                               &
-                   ql(k,j,i) >= ql_crit )  CYCLE
+             IF ( number_of_particles <= 0  .OR.  ql(k,j,i) >= ql_crit )  CYCLE
              particles => grid_particles(k,j,i)%particles(1:number_of_particles)
 !
-!--          Start merging operations: This routine delete super droplets with
-!--          a small radius (radius <= radius_merge) and a low weighting 
-!--          factor (weight_factor  <= weight_factor_merge). The number of 
-!--          represented particles will be added to the next particle of the 
-!--          particle array. Tests showed that this simplified method can be 
-!--          used because it will only take place outside of cloudy grid 
-!--          boxes where ql <= 1.0E-5 kg/kg. Therefore, especially former cloned
-!--          and subsequent evaporated super droplets will be merged.
+!--          Start merging operations: This routine deletes super droplets with a small radius
+!--          (radius <= radius_merge) and a low weighting factor (weight_factor  <=
+!--          weight_factor_merge). The number of represented particles will be added to the next
+!--          particle of the particle array. Tests showed that this simplified method can be used
+!--          because it will only take place outside of cloudy grid boxes where ql <= 1.0E-5 kg/kg.
+!--          Therefore, especially former cloned and subsequent evaporated super droplets will be
+!--          merged.
              DO  n = 1, number_of_particles-1
-                IF ( particles(n)%particle_mask                    .AND.       &
-                     particles(n+1)%particle_mask                  .AND.       &
-                     particles(n)%radius        <= radius_merge    .AND.       &
-                     particles(n)%weight_factor <= weight_factor_merge )       &
+                IF ( particles(n)%particle_mask                    .AND.                           &
+                     particles(n+1)%particle_mask                  .AND.                           &
+                     particles(n)%radius        <= radius_merge    .AND.                           &
+                     particles(n)%weight_factor <= weight_factor_merge )                           &
                 THEN
-                   particles(n+1)%weight_factor  =                             &
-                                       particles(n+1)%weight_factor +          &
-                                       ( particles(n)%radius**3     /          &
-                                         particles(n+1)%radius**3   *          &
-                                         particles(n)%weight_factor            &
-                                       )
+                   particles(n+1)%weight_factor  = particles(n+1)%weight_factor +                  &
+                                                   ( particles(n)%radius**3     /                  &
+                                                     particles(n+1)%radius**3   *                  &
+                                                     particles(n)%weight_factor                    &
+                                                   )
                    particles(n)%particle_mask = .FALSE.
-                   deleted_particles          = deleted_particles + 1 
+                   deleted_particles          = deleted_particles + 1
                    merge_drp                  = merge_drp + 1
 
@@ -7379,21 +7119,18 @@
  END SUBROUTINE lpm_merging
 
- 
-
- 
-!------------------------------------------------------------------------------!
+
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Exchange between subdomains.
-!> As soon as one particle has moved beyond the boundary of the domain, it
-!> is included in the relevant transfer arrays and marked for subsequent
-!> deletion on this PE.
-!> First sweep for crossings in x direction. Find out first the number of
-!> particles to be transferred and allocate temporary arrays needed to store
-!> them.
-!> For a one-dimensional decomposition along y, no transfer is necessary,
-!> because the particle remains on the PE, but the particle coordinate has to
-!> be adjusted.
-!------------------------------------------------------------------------------!
+!> As soon as one particle has moved beyond the boundary of the domain, it is included in the
+!> relevant transfer arrays and marked for subsequent deletion on this PE.
+!> First sweep for crossings in x direction. Find out first the number of particles to be
+!> transferred and allocate temporary arrays needed to store them.
+!> For a one-dimensional decomposition along y, no transfer is necessary, because the particle
+!> remains on the PE, but the particle coordinate has to be adjusted.
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE lpm_exchange_horiz
 
@@ -7401,5 +7138,5 @@
     INTEGER(iwp) ::  jp                !< index variable along y
     INTEGER(iwp) ::  kp                !< index variable along z
-    INTEGER(iwp) ::  n                 !< particle index variable 
+    INTEGER(iwp) ::  n                 !< particle index variable
 
 #if defined( __parallel )
@@ -7432,13 +7169,10 @@
 !
 !-- Exchange between subdomains.
-!-- As soon as one particle has moved beyond the boundary of the domain, it
-!-- is included in the relevant transfer arrays and marked for subsequent
-!-- deletion on this PE.
-!-- First sweep for crossings in x direction. Find out first the number of
-!-- particles to be transferred and allocate temporary arrays needed to store
-!-- them.
-!-- For a one-dimensional decomposition along y, no transfer is necessary,
-!-- because the particle remains on the PE, but the particle coordinate has to
-!-- be adjusted.
+!-- As soon as one particle has moved beyond the boundary of the domain, it is included in the
+!-- relevant transfer arrays and marked for subsequent deletion on this PE.
+!-- First sweep for crossings in x direction. Find out first the number of particles to be
+!-- transferred and allocate temporary arrays needed to store them.
+!-- For a one-dimensional decomposition along y, no transfer is necessary, because the particle
+!-- remains on the PE, but the particle coordinate has to be adjusted.
     trlp_count  = 0
     trrp_count  = 0
@@ -7449,6 +7183,6 @@
     IF ( pdims(1) /= 1 )  THEN
 !
-!--    First calculate the storage necessary for sending and receiving the data.
-!--    Compute only first (nxl) and last (nxr) loop iterration.
+!--    First calculate the storage necessary for sending and receiving the data. Compute only first
+!--    (nxl) and last (nxr) loop iterration.
        DO  ip = nxl, nxr, nxr - nxl
           DO  jp = nys, nyn
@@ -7499,6 +7233,5 @@
              DO  n = 1, number_of_particles
 !
-!--             Only those particles that have not been marked as 'deleted' may
-!--             be moved.
+!--             Only those particles that have not been marked as 'deleted' may be moved.
                 IF ( particles(n)%particle_mask )  THEN
 
@@ -7551,6 +7284,6 @@
                       ELSE
 !
-!--                      Store particle data in the transfer array, which will be 
-!--                      send to the neighbouring PE
+!--                      Store particle data in the transfer array, which will be send to the
+!--                      neighbouring PE
                          trlp_count = trlp_count + 1
                          trlp(trlp_count) = particles(n)
@@ -7569,12 +7302,11 @@
                             IF ( pdims(1) == 1 )  THEN
                                particles(n)%x = particles(n)%x - ( nx + 1 ) * dx
-                               particles(n)%origin_x = particles(n)%origin_x - &
-                               ( nx + 1 ) * dx
+                               particles(n)%origin_x = particles(n)%origin_x - ( nx + 1 ) * dx
                             ELSE
                                trrp_count = trrp_count + 1
                                trrp(trrp_count) = particles(n)
                                trrp(trrp_count)%x = trrp(trrp_count)%x - ( nx + 1 ) * dx
-                               trrp(trrp_count)%origin_x = trrp(trrp_count)%origin_x - &
-                               ( nx + 1 ) * dx
+                               trrp(trrp_count)%origin_x = trrp(trrp_count)%origin_x -             &
+                                                           ( nx + 1 ) * dx
                                particles(n)%particle_mask = .FALSE.
                                deleted_particles = deleted_particles + 1
@@ -7597,6 +7329,6 @@
                       ELSE
 !
-!--                      Store particle data in the transfer array, which will be send
-!--                      to the neighbouring PE
+!--                      Store particle data in the transfer array, which will be send to the
+!--                      neighbouring PE
                          trrp_count = trrp_count + 1
                          trrp(trrp_count) = particles(n)
@@ -7615,32 +7347,31 @@
 
 !
-!-- STORAGE_SIZE returns the storage size of argument A in bits. However , it 
+!-- STORAGE_SIZE returns the storage size of argument A in bits. However , it
 !-- is needed in bytes. The function C_SIZEOF which produces this value directly
 !-- causes problems with gfortran. For this reason the use of C_SIZEOF is avoided
-    par_size = STORAGE_SIZE(trlp(1))/8
-
-
-!
-!-- Allocate arrays required for north-south exchange, as these
-!-- are used directly after particles are exchange along x-direction.
-    ALLOCATE( move_also_north(1:NR_2_direction_move) )
-    ALLOCATE( move_also_south(1:NR_2_direction_move) )
+    par_size = STORAGE_SIZE( trlp(1) ) / 8
+
+
+!
+!-- Allocate arrays required for north-south exchange, as these are used directly after particles
+!-- are exchange along x-direction.
+    ALLOCATE( move_also_north(1:nr_2_direction_move) )
+    ALLOCATE( move_also_south(1:nr_2_direction_move) )
 
     nr_move_north = 0
     nr_move_south = 0
 !
-!-- Send left boundary, receive right boundary (but first exchange how many
-!-- and check, if particle storage must be extended)
+!-- Send left boundary, receive right boundary (but first exchange how many and check, if particle
+!-- storage must be extended)
     IF ( pdims(1) /= 1 )  THEN
 
-       CALL MPI_SENDRECV( trlp_count,      1, MPI_INTEGER, pleft,  0, &
-                          trrp_count_recv, 1, MPI_INTEGER, pright, 0, &
+       CALL MPI_SENDRECV( trlp_count,      1, MPI_INTEGER, pleft,  0,                              &
+                          trrp_count_recv, 1, MPI_INTEGER, pright, 0,                              &
                           comm2d, status, ierr )
 
        ALLOCATE(rvrp(MAX(1,trrp_count_recv)))
 
-       CALL MPI_SENDRECV( trlp, max(1,trlp_count)*par_size, MPI_BYTE,&
-                          pleft, 1, rvrp,                            &
-                          max(1,trrp_count_recv)*par_size, MPI_BYTE, pright, 1,&
+       CALL MPI_SENDRECV( trlp, MAX(1,trlp_count)*par_size,      MPI_BYTE, pleft, 1,               &
+                          rvrp, MAX(1,trrp_count_recv)*par_size, MPI_BYTE, pright, 1,              &
                           comm2d, status, ierr )
 
@@ -7651,15 +7382,14 @@
 !
 !--    Send right boundary, receive left boundary
-       CALL MPI_SENDRECV( trrp_count,      1, MPI_INTEGER, pright, 0, &
-                          trlp_count_recv, 1, MPI_INTEGER, pleft,  0, &
+       CALL MPI_SENDRECV( trrp_count,      1, MPI_INTEGER, pright, 0,                              &
+                          trlp_count_recv, 1, MPI_INTEGER, pleft,  0,                              &
                           comm2d, status, ierr )
 
        ALLOCATE(rvlp(MAX(1,trlp_count_recv)))
 !
-!--    This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit 
-!--    variables in structure particle_type (due to the calculation of par_size)
-       CALL MPI_SENDRECV( trrp, max(1,trrp_count)*par_size, MPI_BYTE,&
-                          pright, 1, rvlp,                           &
-                          max(1,trlp_count_recv)*par_size, MPI_BYTE, pleft, 1, &
+!--    This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit variables in structure
+!--    particle_type (due to the calculation of par_size)
+       CALL MPI_SENDRECV( trrp, MAX(1,trrp_count)*par_size,      MPI_BYTE, pright, 1,              &
+                          rvlp, MAX(1,trlp_count_recv)*par_size, MPI_BYTE,  pleft, 1,              &
                           comm2d, status, ierr )
 
@@ -7672,11 +7402,10 @@
 
 !
-!-- Check whether particles have crossed the boundaries in y direction. Note 
-!-- that this case can also apply to particles that have just been received
-!-- from the adjacent right or left PE.
-!-- Find out first the number of particles to be transferred and allocate
-!-- temporary arrays needed to store them.
-!-- For a one-dimensional decomposition along y, no transfer is necessary,
-!-- because the particle remains on the PE.
+!-- Check whether particles have crossed the boundaries in y direction. Note that this case can also
+!-- apply to particles that have just been received from the adjacent right or left PE.
+!-- Find out first the number of particles to be transferred and allocate temporary arrays needed to
+!-- store them.
+!-- For a one-dimensional decomposition along y, no transfer is necessary, because the particle
+!-- remains on the PE.
     trsp_count  = nr_move_south
     trnp_count  = nr_move_north
@@ -7687,6 +7416,5 @@
     IF ( pdims(2) /= 1 )  THEN
 !
-!--    First calculate the storage necessary for sending and receiving the
-!--    data
+!--    First calculate the storage necessary for sending and receiving the data
        DO  ip = nxl, nxr
           DO  jp = nys, nyn, nyn-nys    !compute only first (nys) and last (nyn) loop iterration
@@ -7737,6 +7465,5 @@
              DO  n = 1, number_of_particles
 !
-!--             Only those particles that have not been marked as 'deleted' may
-!--             be moved.
+!--             Only those particles that have not been marked as 'deleted' may be moved.
                 IF ( particles(n)%particle_mask )  THEN
 
@@ -7755,13 +7482,11 @@
                             IF ( pdims(2) == 1 )  THEN
                                particles(n)%y = ( ny + 1 ) * dy + particles(n)%y
-                               particles(n)%origin_y = ( ny + 1 ) * dy + &
-                                                     particles(n)%origin_y
+                               particles(n)%origin_y = ( ny + 1 ) * dy + particles(n)%origin_y
                             ELSE
                                trsp_count         = trsp_count + 1
                                trsp(trsp_count)   = particles(n)
-                               trsp(trsp_count)%y = ( ny + 1 ) * dy + &
-                                                 trsp(trsp_count)%y
-                               trsp(trsp_count)%origin_y = trsp(trsp_count)%origin_y &
-                                                + ( ny + 1 ) * dy
+                               trsp(trsp_count)%y = ( ny + 1 ) * dy + trsp(trsp_count)%y
+                               trsp(trsp_count)%origin_y = trsp(trsp_count)%origin_y               &
+                                                           + ( ny + 1 ) * dy
                                particles(n)%particle_mask = .FALSE.
                                deleted_particles = deleted_particles + 1
@@ -7770,6 +7495,5 @@
                                   trsp(trsp_count)%y = trsp(trsp_count)%y - 1.0E-10_wp
                                   !++ why is 1 subtracted in next statement???
-                                  trsp(trsp_count)%origin_y =                        &
-                                                  trsp(trsp_count)%origin_y - 1
+                                  trsp(trsp_count)%origin_y = trsp(trsp_count)%origin_y - 1
                                ENDIF
 
@@ -7791,6 +7515,6 @@
                       ELSE
 !
-!--                      Store particle data in the transfer array, which will 
-!--                      be send to the neighbouring PE
+!--                      Store particle data in the transfer array, which will be send to the
+!--                      neighbouring PE
                          trsp_count = trsp_count + 1
                          trsp(trsp_count) = particles(n)
@@ -7809,13 +7533,11 @@
                             IF ( pdims(2) == 1 )  THEN
                                particles(n)%y        = particles(n)%y - ( ny + 1 ) * dy
-                               particles(n)%origin_y =                         &
-                                          particles(n)%origin_y - ( ny + 1 ) * dy
+                               particles(n)%origin_y = particles(n)%origin_y - ( ny + 1 ) * dy
                             ELSE
                                trnp_count         = trnp_count + 1
                                trnp(trnp_count)   = particles(n)
-                               trnp(trnp_count)%y =                            &
-                                          trnp(trnp_count)%y - ( ny + 1 ) * dy
-                               trnp(trnp_count)%origin_y =                     &
-                                         trnp(trnp_count)%origin_y - ( ny + 1 ) * dy
+                               trnp(trnp_count)%y = trnp(trnp_count)%y - ( ny + 1 ) * dy
+                               trnp(trnp_count)%origin_y =                                         &
+                                                         trnp(trnp_count)%origin_y - ( ny + 1 ) * dy
                                particles(n)%particle_mask = .FALSE.
                                deleted_particles          = deleted_particles + 1
@@ -7837,6 +7559,6 @@
                       ELSE
 !
-!--                      Store particle data in the transfer array, which will 
-!--                      be send to the neighbouring PE
+!--                      Store particle data in the transfer array, which will be send to the
+!--                      neighbouring PE
                          trnp_count = trnp_count + 1
                          trnp(trnp_count) = particles(n)
@@ -7854,6 +7576,6 @@
 
 !
-!-- Send front boundary, receive back boundary (but first exchange how many
-!-- and check, if particle storage must be extended)
+!-- Send front boundary, receive back boundary (but first exchange how many and check, if particle
+!-- storage must be extended)
     IF ( pdims(2) /= 1 )  THEN
 
@@ -7864,9 +7586,8 @@
        ALLOCATE(rvnp(MAX(1,trnp_count_recv)))
 !
-!--    This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit 
-!--    variables in structure particle_type (due to the calculation of par_size)
-       CALL MPI_SENDRECV( trsp, trsp_count*par_size, MPI_BYTE,      &
-                          psouth, 1, rvnp,                             &
-                          trnp_count_recv*par_size, MPI_BYTE, pnorth, 1,   &
+!--    This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit variables in structure
+!--    particle_type (due to the calculation of par_size)
+       CALL MPI_SENDRECV( trsp, trsp_count*par_size,      MPI_BYTE, psouth, 1,                     &
+                          rvnp, trnp_count_recv*par_size, MPI_BYTE, pnorth, 1,                     &
                           comm2d, status, ierr )
 
@@ -7877,15 +7598,14 @@
 !
 !--    Send back boundary, receive front boundary
-       CALL MPI_SENDRECV( trnp_count,      1, MPI_INTEGER, pnorth, 0, &
-                          trsp_count_recv, 1, MPI_INTEGER, psouth, 0, &
+       CALL MPI_SENDRECV( trnp_count,      1, MPI_INTEGER, pnorth, 0,                              &
+                          trsp_count_recv, 1, MPI_INTEGER, psouth, 0,                              &
                           comm2d, status, ierr )
 
        ALLOCATE(rvsp(MAX(1,trsp_count_recv)))
 !
-!--    This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit 
-!--    variables in structure particle_type (due to the calculation of par_size)
-       CALL MPI_SENDRECV( trnp, trnp_count*par_size, MPI_BYTE,      &
-                          pnorth, 1, rvsp,                          &
-                          trsp_count_recv*par_size, MPI_BYTE, psouth, 1,   &
+!--    This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit variables in structure
+!--    particle_type (due to the calculation of par_size)
+       CALL MPI_SENDRECV( trnp, trnp_count*par_size,      MPI_BYTE, pnorth, 1,                     &
+                          rvsp, trsp_count_recv*par_size, MPI_BYTE, psouth, 1,                     &
                           comm2d, status, ierr )
 
@@ -7922,6 +7642,5 @@
 !--                   Cyclic boundary. Relevant coordinate has to be changed.
                       particles(n)%x = ( nx + 1 ) * dx + particles(n)%x
-                      particles(n)%origin_x = ( nx + 1 ) * dx + &
-                               particles(n)%origin_x
+                      particles(n)%origin_x = ( nx + 1 ) * dx + particles(n)%origin_x
                    ELSEIF ( ibc_par_lr == 1 )  THEN
 !
@@ -7943,6 +7662,5 @@
 !--                   Cyclic boundary. Relevant coordinate has to be changed.
                       particles(n)%x = particles(n)%x - ( nx + 1 ) * dx
-                      particles(n)%origin_x = particles(n)%origin_x - &
-                               ( nx + 1 ) * dx
+                      particles(n)%origin_x = particles(n)%origin_x - ( nx + 1 ) * dx
 
                    ELSEIF ( ibc_par_lr == 1 )  THEN
@@ -7979,6 +7697,5 @@
 !--                   Cyclic boundary. Relevant coordinate has to be changed.
                       particles(n)%y = ( ny + 1 ) * dy + particles(n)%y
-                      particles(n)%origin_y = ( ny + 1 ) * dy + &
-                           particles(n)%origin_y
+                      particles(n)%origin_y = ( ny + 1 ) * dy + particles(n)%origin_y
 
                    ELSEIF ( ibc_par_ns == 1 )  THEN
@@ -8001,6 +7718,5 @@
 !--                   Cyclic boundary. Relevant coordinate has to be changed.
                       particles(n)%y = particles(n)%y - ( ny + 1 ) * dy
-                      particles(n)%origin_y = particles(n)%origin_y - &
-                                ( ny + 1 ) * dy
+                      particles(n)%origin_y = particles(n)%origin_y - ( ny + 1 ) * dy
 
                    ELSEIF ( ibc_par_ns == 1 )  THEN
@@ -8043,11 +7759,11 @@
 
 #if defined( __parallel )
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> If a particle moves from one processor to another, this subroutine moves 
-!> the corresponding elements from the particle arrays of the old grid cells 
-!> to the particle arrays of the new grid cells.
-!------------------------------------------------------------------------------!
+!> If a particle moves from one processor to another, this subroutine moves the corresponding
+!> elements from the particle arrays of the old grid cells to the particle arrays of the new grid
+!> cells.
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE lpm_add_particles_to_gridcell (particle_array)
 
@@ -8065,7 +7781,8 @@
     TYPE(particle_type), DIMENSION(:), ALLOCATABLE ::  temp_ns        !< temporary particle array for reallocation
 
+
     pack_done     = .FALSE.
 
-    DO  n = 1, SIZE(particle_array)
+    DO  n = 1, SIZE( particle_array )
 
        IF ( .NOT. particle_array(n)%particle_mask )  CYCLE
@@ -8075,6 +7792,6 @@
 !
 !--    In case of stretching the actual k index must be found
-       IF ( dz_stretch_level /= -9999999.9_wp  .OR.         &
-            dz_stretch_level_start(1) /= -9999999.9_wp )  THEN
+       IF ( dz_stretch_level /= -9999999.9_wp  .OR.  dz_stretch_level_start(1) /= -9999999.9_wp )  &
+       THEN
           kp = MAX( MINLOC( ABS( particle_array(n)%z - zu ), DIM = 1 ) - 1, 1 )
        ELSE
@@ -8082,11 +7799,12 @@
        ENDIF
 
-       IF ( ip >= nxl  .AND.  ip <= nxr  .AND.  jp >= nys  .AND.  jp <= nyn    &
-            .AND.  kp >= nzb+1  .AND.  kp <= nzt)  THEN ! particle stays on processor
+       IF ( ip >= nxl    .AND.  ip <= nxr  .AND.  jp >= nys  .AND.  jp <= nyn  .AND.               &
+            kp >= nzb+1  .AND.  kp <= nzt)  THEN  ! particle stays on processor
+
           number_of_particles = prt_count(kp,jp,ip)
           particles => grid_particles(kp,jp,ip)%particles(1:number_of_particles)
 
           pindex = prt_count(kp,jp,ip)+1
-          IF( pindex > SIZE(grid_particles(kp,jp,ip)%particles) )  THEN
+          IF( pindex > SIZE( grid_particles(kp,jp,ip)%particles ) )  THEN
              IF ( pack_done )  THEN
                 CALL realloc_particles_array ( ip, jp, kp )
@@ -8095,5 +7813,5 @@
                 prt_count(kp,jp,ip) = number_of_particles
                 pindex = prt_count(kp,jp,ip)+1
-                IF ( pindex > SIZE(grid_particles(kp,jp,ip)%particles) )  THEN
+                IF ( pindex > SIZE( grid_particles(kp,jp,ip)%particles ) )  THEN
                    CALL realloc_particles_array ( ip, jp, kp )
                 ENDIF
@@ -8103,19 +7821,20 @@
           grid_particles(kp,jp,ip)%particles(pindex) = particle_array(n)
           prt_count(kp,jp,ip) = pindex
+
        ELSE
+
           IF ( jp <= nys - 1 )  THEN
+
              nr_move_south = nr_move_south+1
 !
-!--          Before particle information is swapped to exchange-array, check 
-!--          if enough memory is allocated. If required, reallocate exchange
-!--          array.
-             IF ( nr_move_south > SIZE(move_also_south) )  THEN
-!
-!--             At first, allocate further temporary array to swap particle 
-!--             information.
-                ALLOCATE( temp_ns(SIZE(move_also_south)+NR_2_direction_move) )
+!--          Before particle information is swapped to exchange-array, check if enough memory is
+!--          allocated. If required, reallocate exchange array.
+             IF ( nr_move_south > SIZE( move_also_south ) )  THEN
+!
+!--             At first, allocate further temporary array to swap particle information.
+                ALLOCATE( temp_ns(SIZE( move_also_south )+nr_2_direction_move) )
                 temp_ns(1:nr_move_south-1) = move_also_south(1:nr_move_south-1)
                 DEALLOCATE( move_also_south )
-                ALLOCATE( move_also_south(SIZE(temp_ns)) )
+                ALLOCATE( move_also_south(SIZE( temp_ns )) )
                 move_also_south(1:nr_move_south-1) = temp_ns(1:nr_move_south-1)
                 DEALLOCATE( temp_ns )
@@ -8129,8 +7848,8 @@
 !--             Apply boundary condition along y
                 IF ( ibc_par_ns == 0 )  THEN
-                   move_also_south(nr_move_south)%y =                          &
-                      move_also_south(nr_move_south)%y + ( ny + 1 ) * dy
-                   move_also_south(nr_move_south)%origin_y =                   &
-                      move_also_south(nr_move_south)%origin_y + ( ny + 1 ) * dy
+                   move_also_south(nr_move_south)%y =                                              &
+                                                  move_also_south(nr_move_south)%y + ( ny + 1 ) * dy
+                   move_also_south(nr_move_south)%origin_y =                                       &
+                                           move_also_south(nr_move_south)%origin_y + ( ny + 1 ) * dy
                 ELSEIF ( ibc_par_ns == 1 )  THEN
 !
@@ -8142,25 +7861,24 @@
 !
 !--                Particle reflection
-                   move_also_south(nr_move_south)%y       =                    &
-                      -move_also_south(nr_move_south)%y
-                   move_also_south(nr_move_south)%speed_y =                    &
-                      -move_also_south(nr_move_south)%speed_y
+                   move_also_south(nr_move_south)%y       = -move_also_south(nr_move_south)%y
+                   move_also_south(nr_move_south)%speed_y = -move_also_south(nr_move_south)%speed_y
 
                 ENDIF
+
              ENDIF
+
           ELSEIF ( jp >= nyn+1 )  THEN
+
              nr_move_north = nr_move_north+1
 !
-!--          Before particle information is swapped to exchange-array, check 
-!--          if enough memory is allocated. If required, reallocate exchange
-!--          array.
-             IF ( nr_move_north > SIZE(move_also_north) )  THEN
-!
-!--             At first, allocate further temporary array to swap particle 
-!--             information.
-                ALLOCATE( temp_ns(SIZE(move_also_north)+NR_2_direction_move) )
+!--          Before particle information is swapped to exchange-array, check if enough memory is
+!--          allocated. If required, reallocate exchange array.
+             IF ( nr_move_north > SIZE( move_also_north ) )  THEN
+!
+!--             At first, allocate further temporary array to swap particle information.
+                ALLOCATE( temp_ns(SIZE( move_also_north )+nr_2_direction_move) )
                 temp_ns(1:nr_move_north-1) = move_also_south(1:nr_move_north-1)
                 DEALLOCATE( move_also_north )
-                ALLOCATE( move_also_north(SIZE(temp_ns)) )
+                ALLOCATE( move_also_north(SIZE( temp_ns )) )
                 move_also_north(1:nr_move_north-1) = temp_ns(1:nr_move_north-1)
                 DEALLOCATE( temp_ns )
@@ -8174,8 +7892,8 @@
                 IF ( ibc_par_ns == 0 )  THEN
 
-                   move_also_north(nr_move_north)%y =                          &
-                      move_also_north(nr_move_north)%y - ( ny + 1 ) * dy
-                   move_also_north(nr_move_north)%origin_y =                   &
-                      move_also_north(nr_move_north)%origin_y - ( ny + 1 ) * dy
+                   move_also_north(nr_move_north)%y =                                              &
+                                                  move_also_north(nr_move_north)%y - ( ny + 1 ) * dy
+                   move_also_north(nr_move_north)%origin_y =                                       &
+                                           move_also_north(nr_move_north)%origin_y - ( ny + 1 ) * dy
                 ELSEIF ( ibc_par_ns == 1 )  THEN
 !
